﻿'Importando la Capa de Entidades y la Capa Logica
'Importacion necesaria para trabajar con las imagenes
Imports ENTIDADES
Imports System.Windows.Forms
Imports BLL

Public Class frmDocumentos
    '**************  DECLARACION DE VARIABLES GLOBALES ****************'
    Private objDocumento As New DocumentosBL
    Private eDocumento As New Documentos
    Private objPersona As New PersonasBL
    Private ePersona As New Personas
    Private sw As Integer
    Private campo As String
    Private objFuncion As New miFuncion.funciones

    '******************** METODOS *************************************'
    Public Sub botones(ByVal x As Boolean)
        btnAñadir.Enabled = Not x
        btnModificar.Enabled = Not x
        btnEliminar.Enabled = Not x
        btnGrabar.Enabled = x
        Panel2.Enabled = x
    End Sub

    '***************************** Limpiar los TextBox ******************************'
    Public Sub Limpiar(ByVal Grupo As System.Windows.Forms.Panel)
        Dim miControl As Object
        Try
            For Each miControl In Grupo.Controls
                If miControl.GetType Is GetType(TextBox) Then
                    miControl.Clear()
                End If
                If miControl.GetType Is GetType(MaskedTextBox) Then
                    miControl.Clear()
                End If
                System.Windows.Forms.Application.DoEvents()
            Next
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Public Sub New()
        MyBase.New
        InitializeComponent()
    End Sub

    '**********  EL EVENTO LOAD DEL FORMULARIO**********************'
    Private Sub FrmDocumentos_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        botones(False)
        cambioColor()

        Try
            Call ListarDocumentos()
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Advertencia", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    '********************+ Controla los colores del DatagridView ************************
    Sub cambioColor()
        ' desactivar los estilos visuales del sistema
        Me.Dgv.EnableHeadersVisualStyles = False

        ' estilo para las cabeceras
        Dim styCabeceras As DataGridViewCellStyle = New DataGridViewCellStyle()
        styCabeceras.BackColor = Color.LightYellow
        ' styCabeceras.ForeColor = Color.MediumAquamarine
        styCabeceras.ForeColor = Color.MediumBlue
        styCabeceras.Font = New Font("Comic Sans MS", 10, FontStyle.Italic Or FontStyle.Bold)

        ' asignar estilo al grid
        Me.Dgv.ColumnHeadersDefaultCellStyle = styCabeceras
    End Sub

    '*************************** Presentar los datos en el DataGridView y en los TextBox *************+'
    Private Sub ListarDocumentos()
        Try
            LimpiaDgv()
            Limpiar(Panel2)
            DocumentosBindingSource.DataSource = objDocumento.GetAll()
            If DocumentosBindingSource.Count = 0 Then
                MessageBox.Show("No hay Documentos, proceda por Añadir", "Advertencia", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                btnAñadir.Focus()
            Else
                Dgv.DataSource = DocumentosBindingSource
                Dim vDocumento As Documentos = TryCast(DocumentosBindingSource.Current, Documentos)
                MuestraDatos(vDocumento)
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Advertencia", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub FrmDocumentos_Activated(sender As Object, e As EventArgs) Handles MyBase.Activated
        btnAñadir.Focus()
    End Sub

    Private Sub MuestraDatos(vDocumento As Documentos)
        txtIdDocu.Text = Convert.ToString(vDocumento.IdDocu)
        txtIdPerso.Text = Convert.ToString(vDocumento.IdPerso)
        txtFecha.Text = Convert.ToString(vDocumento.Fecha)
        txtDocumento.Text = vDocumento.Documento
        '*************Capturar Nombre de la persona ****************'
        ePersona = objPersona.GetByID(vDocumento.IdPerso)
        txtNombre.Text = objPersona.GetByID(ePersona.IdPerso).Nombre
    End Sub

    '**********  EL EVENTO CLICK DEL BOTON AÑADIR********************'
    Private Sub BtnAñadir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAñadir.Click
        sw = 1
        botones(True)
        Limpiar(Panel2)
        LabelInfo.Text = ""
        txtFecha.Focus()
    End Sub

    '**********  EL EVENTO CLICK DEL BOTON MODIFICAR****************'
    Private Sub BtnModificar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnModificar.Click
        sw = 2
        botones(True)
        LabelInfo.Text = ""
        txtFecha.Focus()
    End Sub

    '**********  EL EVENTO CLICK DEL BOTON ELIMINAR****************'
    Private Sub BtnEliminar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEliminar.Click
        sw = 3
        LabelInfo.Text = ""
        botones(True)
        txtFecha.Focus()
    End Sub

    '**********  EL EVENTO CLICK DEL BOTON GRABAR***************'
    Private Sub BtnGrabar_Click(sender As Object, e As EventArgs) Handles btnGrabar.Click
        Try
            LabelInfo.Text = ""
            Select Case sw
                Case 1
                    Dim eDocumento As New Documentos With {
                        .IdPerso = Convert.ToInt32(txtIdPerso.Text),
                        .Fecha = Convert.ToDateTime(txtFecha.Text),
                        .Documento = RTrim(txtDocumento.Text)
                    }
                    If objDocumento.Insertar(eDocumento) Then
                        LabelInfo.Text = "Registro insertado correctamente"
                    End If
                Case 2
                    Dim DocumentoEditar As New Documentos With {
                        .IdPerso = Convert.ToInt32(txtIdPerso.Text),
                        .Fecha = Convert.ToDateTime(txtFecha.Text),
                        .Documento = txtDocumento.Text
                    }
                    If objDocumento.Update(DocumentoEditar) Then
                        LabelInfo.Text = "Registro actualizado correctamente"
                    End If
                Case 3
                    If Dgv.CurrentRow.Selected Then
                        Dim vDocumento As Documentos = TryCast(DocumentosBindingSource.Current, Documentos)
                        If (MessageBox.Show("¿Seguro de eliminar este registro ?", "Confirme", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.Yes) Then
                            If objDocumento.Delete(vDocumento.IdDocu) = True Then
                                LabelInfo.Text = "Registro eliminado correctamente"
                            End If
                        End If
                    End If
            End Select
            If sw = 1 Then
                DocumentosBindingSource.MoveLast()
            End If
            Call ListarDocumentos()
        Catch ex As Exception
            If Err.Number = 5 Then
                MessageBox.Show("Este código y la población están cargados en la Base Datos", "Advertencia", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                MessageBox.Show(ex.Message, "Advertencia", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        Finally
            botones(False)
        End Try
    End Sub

    '**********  EL EVENTO CLICK DEL BOTON SALIR********************'
    Private Sub btnSalir_Click(sender As Object, e As EventArgs) Handles btnSalir.Click
        Try
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Information, ToString)
        Finally
            Me.Close()
        End Try
    End Sub

    '************************ Control de campos para pasar de uno a otro con el Intro**********************'
    Private Sub TxtFecha_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtFecha.KeyPress
        Dim ch As Char = e.KeyChar
        If ch = Chr(9) Then
            txtDocumento.Focus()
        End If
    End Sub

    Private Sub TxtDocumento_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtDocumento.KeyPress
        Dim ch As Char = e.KeyChar
        If ch = Chr(9) Then
            txtNombre.Focus()
        End If
    End Sub

    Private Sub TxtDocumento_Validating(sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles txtDocumento.Validating
        txtDocumento.Text = StrConv(txtDocumento.Text, VbStrConv.ProperCase)
        If Trim(txtDocumento.Text) = "" Then
            MsgBox("El nombre del Documento es obligatorio")
            e.Cancel = True
        End If
    End Sub

    '******************** Se utiliza para pasar el código de provincia al formulario de Documentos ***************'
    Private Sub TxtNombre_Click(sender As Object, e As System.EventArgs) Handles txtNombre.Click
        Try
            Dim FPersonas As New frmPersonas()
            AddHandler FPersonas.EnviarPersona, AddressOf MostrarPersona
            FPersonas.ShowDialog()
            Me.Show()
            txtIdPerso.ReadOnly = False
        Catch ex As Exception
            MessageBox.Show("Error:" & ex.ToString)
        End Try
    End Sub

    Private Sub MostrarPersona(ePersona As Personas)
        Me.txtIdPerso.Text = Trim(ePersona.IdPerso)
        Me.txtNombre.Text = ePersona.Nombre
    End Sub

    Private Sub TxtNombre_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtNombre.KeyPress
        Dim ch As Char = e.KeyChar
        If ch = Chr(9) Then
            btnGrabar.Focus()
        End If
    End Sub

    Private Sub TxtNombre_Validating(sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles txtNombre.Validating
        txtNombre.Text = StrConv(txtDocumento.Text, VbStrConv.ProperCase)
        If Trim(txtNombre.Text) = "" Then
            MsgBox("El nombre del Documento es obligatorio")
            e.Cancel = True
        End If
    End Sub

    '************************ Busqueda por filtreado ***************************
    Private Sub CbBuscar_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles cbBuscar.SelectedIndexChanged
        Try
            txtFiltro.Text = ""
            campo = cbBuscar.SelectedItem.ToString
            txtFiltro.Focus()
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Information, ToString)
        End Try
    End Sub

    Private Sub TxtFiltro_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtFiltro.TextChanged
        If txtFiltro.Text = "" Then
            ListarDocumentos()
        Else
            Filtra(Convert.ToString(txtFiltro.Text))
        End If
    End Sub

    Public Sub Filtra(ByVal texto As String)
        Select Case campo
            Case "Documento"
                DocumentosBindingSource.DataSource = objDocumento.GetByDocumento(texto)
                If DocumentosBindingSource.Count = 0 Then
                    MessageBox.Show("No existe este Documento", "Advertencia", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Else
                    Dgv.DataSource = DocumentosBindingSource
                    Dim vDocumento As Documentos = TryCast(DocumentosBindingSource.Current, Documentos)
                    MuestraDatos(vDocumento)
                End If
            Case "Persona"
                Dim miPerso As New frmPersonas(txtFiltro.Text)
                AddHandler miPerso.EnviarPersona, AddressOf FiltrarPersona
                miPerso.ShowDialog()
            Case "IdPerso"
                DocumentosBindingSource.DataSource = objDocumento.GetByIdPerso(Convert.ToInt32(txtFiltro.Text))    'Trae la comunidad con el código del cliente
                If DocumentosBindingSource.Count = 0 Then
                    MessageBox.Show("No existe esta Persona", "Advertencia", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Else
                    Dgv.DataSource = DocumentosBindingSource
                    Dim vDocumento As Documentos = TryCast(DocumentosBindingSource.Current, Documentos)
                    MuestraDatos(vDocumento)
                End If
        End Select
    End Sub

    Private Sub FiltrarPersona(ePersona As Personas)
        campo = "IdPerso"
        txtFiltro.Text = ePersona.IdPerso
    End Sub

    '**********  EL EVENTO CELLCLICK DE LA GRILLA dgv para poner los datos en los TextBox********************'
    Private Sub Dgv_CellMouseClick(sender As Object, e As DataGridViewCellMouseEventArgs) Handles Dgv.CellMouseClick
        Dim vDocumento As Documentos = TryCast(DocumentosBindingSource.Current, Documentos)
        MuestraDatos(vDocumento)
    End Sub

    Sub LimpiaDgv()
        Try
            Dgv.DataSource = Nothing
        Catch ex As InvalidOperationException ' Esta excepcion es por si ocurriera
            MsgBox("Esta fila no se puede eliminar", MsgBoxStyle.Critical, "Operación inválida : : . . .")
        End Try
    End Sub

    '********************* Capturar los datos de la provincia ***********************
    Private Sub TxtPersonas_Click(sender As Object, e As EventArgs) Handles txtNombre.Click
        Try
            Dim FPersona As New frmPersonas()
            AddHandler FPersona.EnviarPersona, AddressOf MostrarPersonas
            FPersona.ShowDialog()
            Me.Show()
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Information, ToString)
        End Try
    End Sub

    Private Sub MostrarPersonas(ePersona As Personas)
        Me.txtIdPerso.Text = ePersona.IdPerso
        Me.txtNombre.Text = ePersona.Nombre
    End Sub
End Class